local function CanPlayerHurtPlayer(p1,p2,nobs)

	local ff = CV_FindVar("friendlyfire").value
	
	if not (nobs)
		if not p1.mo
			return false
		end
		if not p2.mo
			return false
		end
		
		if not p1.mo.health
			return false
		end
		if not p2.mo.health
			return false
		end
		
		if (p1.powers[pw_flashing] > 2*TICRATE)
			return false
		end
		if ((p2.powers[pw_flashing]) or (p2.powers[pw_invulnerability]) or (p2.powers[pw_super]))
			return false
		end
	end
	
	if (gametyperules & GTR_FRIENDLY)
		if ff
			return true
		end
	else
		if (gametyperules & GTR_TEAMS)
			if p1.ctfteam ~= p2.ctfteam
				return true
			elseif p1.ctfteam == p2.ctfteam
			and ff
				return true
			end
		elseif (gametyperules & (GTR_FRIENDLYFIRE|GTR_RINGSLINGER))
		or ((ff) and (p1.ctfteam == p2.ctfteam))			
			return true
		end
		
	end
	return false

end
local function lookfortarget(p,range)
	local TR = TICRATE
	local me = p.mo
	local px = me.x
	local py = me.y
	local br = range
	
	local targets = {}
	searchBlockmap("objects", function(me, found)
		if found and found.valid
		and (found.health)
			if not (P_CheckSight(me,found))
				return
			end
			
			if (found.flags & (MF_ENEMY|MF_BOSS))
			or (found.flags & MF_MONITOR)
			and (found.type ~= MT_EGGMAN_BOX)
				table.insert(targets,found)
			elseif (found.type == MT_PLAYER)
				if CanPlayerHurtPlayer(p,found.player)
					table.insert(targets,found)
				end
			end
		end
	end, me, px-br, px+br, py-br, py+br)
	//sort from closest to farthest
	table.sort(targets,function(a,b)
		//prioritize players
		if (a.type == MT_PLAYER and b.type ~= MT_PLAYER)
			return true
		end
		
		if R_PointToDist2(me.x,me.y, a.x,a.y) < R_PointToDist2(me.x,me.y, b.x,b.y)
			return true
		end
	end)
	return targets[1] or 0
end
//from clairebun
local function L_ZCollide(mo1,mo2)
	if mo1.z > mo2.height+mo2.z then return false end
	if mo2.z > mo1.height+mo1.z then return false end
	return true
end

//thanks buggie
local function predictballmove(p,speed)
	local mo = p.mo
	local x,y = cos(mo.angle),sin(mo.angle)
	local predict = P_SpawnMobjFromMobj(mo,
		25*x,
		25*y,
		mo.height,MT_PUNCHBALL
	)
	predict.flags = $ &~(MF_SPECIAL|MF_SOLID)
	predict.height,predict.radius = mobjinfo[MT_PUNCHBALL].height,mobjinfo[MT_PUNCHBALL].radius
	predict.state = S_PUNCHBALL_GET
	predict.predicting = true
	
	P_Thrust(predict,mo.angle,speed)
	P_SetObjectMomZ(predict,FixedMul(14*FU, sin(p.aiming)))
	local orbpos = {}
	for i = 1, TICRATE do
		P_XYMovement(predict)
		P_ZMovement(predict)
		
		table.insert(orbpos,{predict.x,predict.y,predict.z})
		
		if (P_IsObjectOnGround(predict))
			break
		end
	end
	local pos = {predict.x,predict.y,predict.z}
	P_RemoveMobj(predict)
	return pos,orbpos
end

addHook("PlayerSpawn",function(p)
	if p.mo.skin == "talez" then
	local x,y = cos(p.drawangle),sin(p.drawangle)
	P_SpawnMobjFromMobj(p.realmo,100*x,100*y,0,MT_PUNCHBALL)
	p.punchball = nil
	end
end)

addHook("PlayerThink",function(p)
	if not p
	or not p.valid
		return
	end
	
	if (p.mo and p.mo.valid)
		local me = p.mo
		
		if (p.punchball == nil) then
			p.punchball = {
				hasone = false,
				wastargetvalid = false,
				holding = 0,
				thrown = 0,
				cursor = 0,
			}
		end
		if (p.punchballtarget == nil)
			p.punchballtarget = false
		end
		
		local pp = p.punchball
		
		if (p.cmd.buttons & BT_ATTACK)
			p.firedown = $+1
		else
			p.firedown = 0
		end
		
		if (pp.hasone)
			if (pp.holding and pp.holding.valid) 
				pp.holding.flags = $|
				(MF_NOGRAVITY|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOCLIP)
				&~ (MF_SPECIAL|MF_SOLID)
				
				pp.holding.momx,pp.holding.momy,pp.holding.momz = 0,0,0
				local z = me.z+(me.height*12/10)
				if (P_MobjFlip(me) == -1) then
					z = me.z-(me.height*12/10)
				end
				P_MoveOrigin(pp.holding,me.x+me.momx,me.y+me.momy,z+me.momz)
				
				if (pp.holding.state ~= S_PUNCHBALL)
					pp.holding.state = S_PUNCHBALL
				end
				pp.holding.beingheld = true
				pp.holding.color = p.skincolor
				
			else
				local z = me.height*12/10*P_MobjFlip(me)
				
				pp.holding = P_SpawnMobjFromMobj(me,0,0,z,MT_PUNCHBALL)
				pp.holding.flags = $|
				(MF_NOGRAVITY|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOCLIP)
				&~ (MF_SPECIAL|MF_SOLID)
			end
			
			//auto aim/auto target
			local speed = FixedHypot(me.momx,me.momy)
			local speedadd = (max(20*me.scale,speed))*21
			p.punchballtarget = lookfortarget(p,25*me.scale+FixedMul(speedadd,me.scale))
			local target = p.punchballtarget
			local shouldlockon = false
			local shouldgrow = false
			if (target and target.valid)
			and (p.cmd.buttons & BT_FIRENORMAL)
				if not (pp.wastargetvalid)
					S_StartSound(nil,sfx_thok,p)
					shouldgrow = true
				end
				P_SpawnLockOn(p,target,S_LOCKON1)
				shouldlockon = true
				pp.wastargetvalid = (p.punchballtarget and p.punchballtarget.valid)
			else
				pp.wastargetvalid = false
			end
			
			if (p == displayplayer)
				local x,y = cos(me.angle),sin(me.angle)
				local speed = FixedHypot(me.momx,me.momy)
				local speedadd = (max(20*me.scale,speed))*21
				local dest = 0
				if not (pp.cursor and pp.cursor.valid)
					pp.cursor = P_SpawnMobjFromMobj(me,
						0,
						0,
						0,MT_THOK
					)
					local dest = pp.cursor
					dest.sprite = SPR_PNBL
					dest.frame = D
					dest.renderflags = $|RF_FLOORSPRITE|RF_SHADOWDRAW|RF_FULLBRIGHT|RF_OBJECTSLOPESPLAT
					dest.color = p.skincolor
					dest.blendmode = AST_ADD
					dest.tics = -1
				end
				
				dest = pp.cursor
				dest.dispoffset = 7
				dest.renderflags = $|RF_FLOORSPRITE|RF_SHADOWDRAW|RF_FULLBRIGHT|RF_OBJECTSLOPESPLAT
				dest.frame = D
				
				local destz = dest.z
				local pos = {}
				local orbpos = {}
				if (shouldlockon)
					if (shouldgrow)
						local oldscale = dest.scale
						dest.scale = $*2
						dest.destscale = oldscale
					end
					
					dest.frame = F
					P_MoveOrigin(dest,
						target.x+target.momx,
						target.y+target.momy,
						target.z+(target.height/2)+target.momz
					)
					dest.renderflags = $ &~(RF_FLOORSPRITE|RF_SHADOWDRAW|RF_FULLBRIGHT|RF_OBJECTSLOPESPLAT)
					dest.rollangle = $-FixedAngle(3*FU)
				else
					if (dest.rollangle)
						dest.rollangle = 0
					end
					dest.scale = me.scale
					pos,orbpos = predictballmove(p,max(20*me.scale,speed))
					P_MoveOrigin(dest,pos[1],pos[2],pos[3])
				end
				destz = dest.z
				
				//aim line
				x,y = cos(R_PointToAngle2(me.x,me.y, dest.x,dest.y)),sin(R_PointToAngle2(me.x,me.y, dest.x,dest.y))
				local distscale = R_PointToDist2(me.x,me.y, dest.x,dest.y)
				local maxline = (distscale/35/FU)
				local diffz = destz-(me.z+(me.height*P_MobjFlip(me)))
				local partz = FixedDiv(diffz,maxline*FU or FU)*P_MobjFlip(me) 
				for i = 1,maxline
					if not (shouldlockon)
						break
					end
					local d = 20
					local line = P_SpawnMobjFromMobj(me,
						(23+(i*b))*x,(23+(i*b))*y,
						(me.height*P_MobjFlip(me))+(partz*i),MT_THOK
					)
					line.scale = FU/3
					line.shadowscale = line.scale*2/3
					line.color = p.skincolor
					line.blendmode = AST_ADD
					line.renderflags = RF_FULLBRIGHT
					line.tics = 2
				end
				if not (shouldlockon)
					for k,v in ipairs(orbpos)
						local line = P_SpawnMobj(
							v[1],v[2],
							v[3],MT_THOK
						)
						line.scale = FU/3
						line.shadowscale = line.scale*2/3
						line.color = p.skincolor
						line.blendmode = AST_ADD
						line.renderflags = RF_FULLBRIGHT
						line.tics = 2
					end
				end
			end
			
			//drop ball
			if (p.playerstate == PST_DEAD)
				if (pp.holding and pp.holding.valid)
					local newball = P_SpawnMobjFromMobj(pp.holding,0,0,0,MT_PUNCHBALL)
					newball.state = S_PUNCHBALL_GET
					P_RemoveMobj(pp.holding)
					pp.hasone = false
				end
			end
			
			//throw the ball
			if (p.firedown == 1)
				if (pp.holding and pp.holding.valid)
					P_RemoveMobj(pp.holding)
				end
				local ang = me.angle
				if shouldlockon
					ang = R_PointToAngle2(me.x,me.y,
						p.punchballtarget.x,p.punchballtarget.y
					)
				end
				local x,y = cos(ang),sin(ang)
				if not (shouldlockon)
					pp.thrown = P_SpawnMobjFromMobj(me,25*x,25*y,me.height*P_MobjFlip(me),MT_PUNCHBALL)
					pp.thrown.angle = ang
					pp.thrown.scale = me.scale
					pp.thrown.tracer = me
					pp.thrown.color = p.skincolor
					pp.hasone = false
					local speed = FixedHypot(me.momx,me.momy)
					P_Thrust(pp.thrown,pp.thrown.angle,max(20*me.scale,speed))
					P_SetObjectMomZ(pp.thrown,FixedMul(14*FU, sin(p.aiming)))
				else
					//pp.hasone = false
					p.mo.target = p.punchballtarget
					A_BrakLobShot(me,MT_PUNCHBALL,32+(1<<16))
					p.mo.target = nil
					pp.hasone = false
				end
			end
			
		else
			if (pp.cursor and pp.cursor.valid)
				P_RemoveMobj(pp.cursor)
			end
		end
		
		if (me.skin == "talez")
			
		end
		
	end
end)

//Punchball stuff
addHook("TouchSpecial",function(ball,s)
	if not s
	or not s.valid
		return
	end
	
	if not s.player
	or not s.player.valid
		return
	end
	
	if (ball.timealive <= 2)
	or (ball.state ~= S_PUNCHBALL_GET)
		return true
	end
	
	if not (s.health)
		return true
	end
	
	local p = s.player
	
	if (p.punchball.hasone)
		return true
	end
	
	p.punchball.hasone = true
	local z = s.height*12/10*P_MobjFlip(s)
	
	p.punchball.holding = P_SpawnMobjFromMobj(s,0,0,z,MT_PUNCHBALL)
	p.punchball.holding.flags = $|
	(MF_NOGRAVITY|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOCLIP)
	&~ (MF_SPECIAL|MF_SOLID)
end,MT_PUNCHBALL)

addHook("MobjSpawn",function(ball)
	if (ball.timealive == nil) then
		ball.timealive = 1
	end
	if (ball.ppcombo == nil) then
		ball.ppcombo = 1
	end
	if (ball.bouncecount == nil) then
		ball.bouncecount = 0
	end
	if (ball.tracer == nil and ball.target == nil)
	and P_IsObjectOnGround(ball)
		ball.state = S_PUNCHBALL_GET
		ball.color = SKINCOLOR_RED
	end
end,MT_PUNCHBALL)

addHook("MobjThinker",function(ball)
	if not ball
	or not ball.valid
		return
	end
	
	if (ball.target and ball.target.valid)
		ball.tracer = ball.target
		ball.tracer.player.punchball.thrown = ball
		ball.state = S_PUNCHBALL
		ball.color = ball.target.player.skincolor
		ball.target = nil
	end
	
	if (not ball.tracer
	or not ball.tracer.valid)
	and (ball.state ~= S_PUNCHBALL_GET)
	and not ball.beingheld
		ball.state = S_PUNCHBALL_GET	
		ball.ppcombo = 0
		ball.friction = FU/10
	end
	
	if (ball.tracer and ball.tracer.valid)
		ball.color = ball.tracer.player.skincolor
	end
	
	if (ball.timealive == nil)
		ball.timealive = 1
	else
		ball.timealive = $+1
	end
	
	if (ball.groundtime == nil)
		ball.groundtime = 1
	end
	if not (ball.flags & MF_NOCLIPHEIGHT)
		if (ball.eflags & MFE_JUSTHITFLOOR)
			if not (ball.bouncecount == 2) then
				local mul = 3-ball.bouncecount
				mul = $*FU
				mul = 2*$/3
				P_SetObjectMomZ(ball, 3*FU+mul)
				ball.bouncecount = $+1
				S_StartSound(ball,sfx_pbounc)
			end
		end
		
		if P_IsObjectOnGround(ball)
			ball.groundtime = $+1
			if ((ball.state ~= S_PUNCHBALL_GET)
			and (ball.bouncecount == 2 or ball.groundtime > 3))
				ball.tracer = nil
				ball.ppcombo = 0
				ball.state = S_PUNCHBALL_GET
				ball.friction = FU/10
				S_StartSound(ball,sfx_psmack)
			end
		else
			ball.groundtime = 0
		end
	end
	
	ball.lastmomz = ball.momz
end,MT_PUNCHBALL)

//let the punchball kill stuff
addHook("MobjMoveCollide",function(ball,mo)
	if not ball
	or not ball.valid
		return
	end
	
	if not mo
	or not mo.valid
		return
	end
	
	if not (ball.tracer and ball.tracer.valid)
		return
	end
	
	if not (L_ZCollide(ball,mo))
		return
	end
	
	if ball.state ~= S_PUNCHBALL
		return
	end
	
	if (mo == ball.tracer)
		return
	end
	
	if not mo.health
		return
	end
	
	if ball.predicting
		return
	end
	
	if (mo.flags & (MF_ENEMY|MF_BOSS))
	or (mo.flags & MF_MONITOR)
	and (mo.type ~= MT_EGGMAN_BOX)
		P_MoveOrigin(ball,mo.x,mo.y,mo.z+mo.height+3*mo.scale)
		P_SetObjectMomZ(ball,4*FU)
		P_KillMobj(mo,ball,ball.tracer)
		S_StartSound(ball,sfx_psmack)
		ball.ppcombo = $+1
		P_AddPlayerScore(ball.tracer.player,100*ball.ppcombo)
	elseif (mo.type == MT_PLAYER)
		if CanPlayerHurtPlayer(ball.tracer.player,mo.player)
			P_MoveOrigin(ball,mo.x,mo.y,mo.z+mo.height+3*mo.scale)
			P_SetObjectMomZ(ball,4*FU)
			P_KillMobj(mo,ball,ball.tracer)
			S_StartSound(ball,sfx_psmack)
			ball.ppcombo = $+1
			P_AddPlayerScore(ball.tracer.player,300*ball.ppcombo)
		end
	end
	
end,MT_PUNCHBALL)

addHook("MobjMoveBlocked",function(ball,_,line)
	if not ball
	or not ball.valid
		return
	end
	
	if not line
	or not line.valid
		return
	end
	
	P_BounceMove(ball)
	S_StartSound(ball,sfx_pbounc)
end,MT_PUNCHBALL)